// No copyright, no warranty; use as you will.
// Written by Ronald Bourret, Technical University of Darmstadt, 1998-9

// Version 1.01
// Changes from version 1.0: None

package de.tudarmstadt.ito.domutils;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

/**
 * DocumentFactory for the Docuverse DOM implementation, version 1.0PR3A.
 *
 * @author Ronald Bourret, Technical University of Darmstadt
 * @version 1.01
 */

public class DF_Docuverse implements DocumentFactory
{
   // ********************************************************************
   // Constructors
   // ********************************************************************

   public DF_Docuverse()
   {
   }

   // ********************************************************************
   // Public methods
   // ********************************************************************

   public Document createDocument() throws DocumentFactoryException
   {
      try
      {
         // Docuverse's DOM cannot create an empty document -- it requires a
         // root element. Fortunately, we can delete this root and return
         // an empty document.

         com.docuverse.dom.DOM dom = new com.docuverse.dom.DOM();
         Document doc = dom.createDocument("temp");
         doc.removeChild((Node)doc.getDocumentElement());
         return doc;
      }
      catch (Exception e)
      {
         throw new DocumentFactoryException(e.getMessage());
      }
   }
}
