// No copyright, no warranty; use as you will.
// Written by Ronald Bourret, Technical University of Darmstadt, 1998-9

// Version 1.01
// Changes from version 1.0: None

package de.tudarmstadt.ito.domutils;

import org.w3c.dom.Document;

/**
 * Interface to encapsulate DOM Document creation.
 *
 * @author Ronald Bourret, Technical University of Darmstadt
 * @version 1.01
 */

public interface DocumentFactory
{
   /**
    * Create an empty DOM Document.
    *
    * @return The newly created Document.
    * @exception DocumentFactoryException Thrown if an error occurs while
    *  creating the Document.
    */
   public Document createDocument() throws DocumentFactoryException;
}
